=== bindings/CMakeLists.txt ===
if(LIBICSNEO_ENABLE_BINDINGS_PYTHON)
	add_subdirectory(python)
endif()
