=== examples/cpp/a2b/CMakeLists.txt ===
add_executable(libicsneocpp-a2b src/a2b.cpp)
target_link_libraries(libicsneocpp-a2b icsneocpp)
